Index: /trunk/kernel/fs/devfs.c
===================================================================
--- /trunk/kernel/fs/devfs.c	(revision 656)
+++ /trunk/kernel/fs/devfs.c	(revision 657)
@@ -3,5 +3,5 @@
  *
  * Author   Mohamed Lamine Karaoui (2014,2015)
- *          Alain Greiner (2016,2017,2018,2019)
+ *          Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) Sorbonne Universites
@@ -53,6 +53,6 @@
 #endif
 
-/////////////////////////////////////
-devfs_ctx_t * devfs_ctx_alloc( void )
+///////////////////////////////////
+xptr_t devfs_ctx_alloc( cxy_t cxy )
 {
     kmem_req_t    req;
@@ -62,26 +62,43 @@
     req.flags   = AF_KERNEL | AF_ZERO;
 
-	return kmem_alloc( &req );
+    // allocates devfs context from target cluster 
+	return XPTR( cxy , kmem_remote_alloc( cxy , &req ) );
 }
 
 /////////////////////////////////////////////
-void devfs_ctx_init( devfs_ctx_t * devfs_ctx,
-                     xptr_t        devfs_dev_inode_xp,
-                     xptr_t        devfs_external_inode_xp )
+void devfs_ctx_init( xptr_t     devfs_ctx_xp,
+                     xptr_t     devfs_dev_inode_xp,
+                     xptr_t     devfs_external_inode_xp )
 {
-    devfs_ctx->dev_inode_xp      = devfs_dev_inode_xp;
-    devfs_ctx->external_inode_xp = devfs_external_inode_xp;
-
-    fs_context[FS_TYPE_DEVFS].extend = devfs_ctx;
+    // get cluster and local pointer on remote devfs context
+    devfs_ctx_t * devfs_ctx_ptr = GET_PTR( devfs_ctx_xp );
+    cxy_t         devfs_ctx_cxy = GET_CXY( devfs_ctx_xp );
+
+    // set values in remote devfs context
+    hal_remote_s64( XPTR( devfs_ctx_cxy  , &devfs_ctx_ptr->dev_inode_xp ),
+                    devfs_dev_inode_xp );
+
+    hal_remote_s64( XPTR( devfs_ctx_cxy  , &devfs_ctx_ptr->external_inode_xp ),
+                    devfs_external_inode_xp );
+
+    // register devfs context in the remote fs_context array[] 
+    hal_remote_spt( XPTR( devfs_ctx_cxy , &fs_context[FS_TYPE_DEVFS].extend ),
+                          devfs_ctx_ptr ); 
 }
 
-/////////////////////////////////////////////////
-void devfs_ctx_destroy( devfs_ctx_t * devfs_ctx )
+//////////////////////////////////////////////
+void devfs_ctx_destroy( xptr_t  devfs_ctx_xp )
 {
     kmem_req_t    req;
 
+    // get cluster and local pointer on devfs context
+    devfs_ctx_t * devfs_ctx_ptr = GET_PTR( devfs_ctx_xp );
+    cxy_t         devfs_ctx_cxy = GET_CXY( devfs_ctx_xp );
+
     req.type = KMEM_KCM;
-    req.ptr  = devfs_ctx;
-    kmem_free( &req );
+    req.ptr  = devfs_ctx_ptr;
+
+    // release devfs context descriptor to remote cluster 
+    kmem_remote_free( devfs_ctx_cxy , &req );
 }
 
@@ -95,4 +112,6 @@
     vfs_inode_t * inode;
 
+    // get 
+
     // create DEVFS "dev" inode in cluster 0
     error = vfs_add_child_in_parent( 0,                // cxy
@@ -158,7 +177,8 @@
 ///////////////////////////////////////////////////
 void devfs_local_init( xptr_t   devfs_dev_inode_xp,
-                       xptr_t   devfs_external_inode_xp,
-                       xptr_t * devfs_internal_inode_xp )
+                       xptr_t   devfs_external_inode_xp )
 {
+    xptr_t        internal_inode_xp;   // extended pointer on <internal> inode
+    vfs_inode_t * internal_inode_ptr;  // local pointer on <internal> inode
     char          node_name[16];
     xptr_t        chdev_xp;
@@ -168,6 +188,7 @@
     vfs_inode_t * inode_ptr;
     uint32_t      channel;
-    xptr_t        unused_xp;    // required by add_child_in_parent()
+    xptr_t        unused_xp;           // required by add_child_in_parent()
     error_t       error;
+    
 
 #if DEBUG_DEVFS_LOCAL_INIT 
@@ -179,20 +200,20 @@
 #endif
 
-    // create "internal" directory 
+    // create <internal> directory 
     snprintf( node_name , 16 , "internal_%x" , local_cxy );
 
-    error = vfs_add_child_in_parent( local_cxy,
-                                     FS_TYPE_DEVFS,
-                                     devfs_dev_inode_xp,
-                                     node_name,
+    error = vfs_add_child_in_parent( local_cxy,              // target cluster
+                                     FS_TYPE_DEVFS,          // FS type
+                                     devfs_dev_inode_xp,     // parent inode
+                                     node_name,              // child name
                                      &unused_xp,
-                                     devfs_internal_inode_xp );
-
-    // set inode "type" field
-    inode_ptr = GET_PTR( *devfs_internal_inode_xp );
-    inode_ptr->type = INODE_TYPE_DEV;
+                                     &internal_inode_xp );   // child inode
+
+    // set <internal> inode "type" field
+    internal_inode_ptr       = GET_PTR( internal_inode_xp );
+    internal_inode_ptr->type = INODE_TYPE_DEV;
  
     // create dentries <.> and <..> in <internal>
-    error |= vfs_add_special_dentries( *devfs_internal_inode_xp,
+    error |= vfs_add_special_dentries( internal_inode_xp,
                                        devfs_dev_inode_xp );
 
@@ -226,5 +247,5 @@
         error = vfs_add_child_in_parent( local_cxy,
                                          FS_TYPE_DEVFS,
-                                         *devfs_internal_inode_xp,
+                                         internal_inode_xp,
                                          chdev_ptr->name,
                                          &unused_xp,
@@ -270,5 +291,5 @@
             error = vfs_add_child_in_parent( local_cxy,
                                              FS_TYPE_DEVFS,
-                                             *devfs_internal_inode_xp,
+                                             internal_inode_xp,
                                              chdev_ptr->name,
                                              &unused_xp,
Index: /trunk/kernel/fs/devfs.h
===================================================================
--- /trunk/kernel/fs/devfs.h	(revision 656)
+++ /trunk/kernel/fs/devfs.h	(revision 657)
@@ -3,5 +3,5 @@
  *
  * Authors       Mohamed Lamine Karaoui (2014,2015)
- *               Alain Greiner (2016,2017)
+ *               Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) 2011,2012 UPMC Sorbonne Universites
@@ -26,7 +26,8 @@
 #define _DEVFS_H_
 
+
 //////////////////////////////////////////////////////////////////////////////////////////
-// The DEVFS File System contains inodes and dentries associated to all chdev descriptors 
-// availables in the architecture. 
+// The DEVFS File System contains the inodes and dentries associated to the chdev
+// descriptors available in the architecture. 
 //
 // It is structured as a three levels tree structure :
@@ -41,8 +42,6 @@
 //
 // The DEVFS extensions to the generic VFS are the following:
-// 1) The vfs_ctx_t "extend" void* field is pointing on the devfs_ctx_t structure.
-//    This structure contains two extended pointers on the DEVFS "dev" directory inode,
-//    and on the "external" directory inode.
-// 2) The vfs_inode_t "extend" void* field is pointing on the chdev descriptor.
+// 1) The vfs_ctx_t "extend" field is pointing on the devfs_ctx_t structure.
+// 2) The vfs_inode_t "extend" field is pointing on the chdev descriptor.
 //////////////////////////////////////////////////////////////////////////////////////////
 
@@ -57,12 +56,12 @@
 }
 devfs_ctx_t;
-
-
 /*****************************************************************************************
- * This fuction allocates memory from local cluster for a DEVFS context descriptor.
+ * This fuction allocates memory for a DEVFS context descriptor in cluster identified
+ * by the <cxy> argument.
  *****************************************************************************************
- * @ return a pointer on the created context / return NULL if failure.
+ * @ cxy     : [in] target cluster identifier.
+ * @ return an extended pointer on the created context / return NULL if failure.
  ****************************************************************************************/
-devfs_ctx_t * devfs_ctx_alloc( void );
+xptr_t  devfs_ctx_alloc( cxy_t cxy );
 
 /*****************************************************************************************
@@ -70,11 +69,11 @@
  * to the relevant VFS context in the local cluster.
  *****************************************************************************************
- * @ devfs_ctx               : local pointer on DEVFS context.
+ * @ devfs_ctx               : [in]  extended pointer on DEVFS context.
  * @ devfs_dev_inode_xp      : [out] extended pointer on  <dev> inode.
  * @ devfs_external_inode_xp : [out] extended pointer on  <external> inode.
  ****************************************************************************************/
-void devfs_ctx_init( devfs_ctx_t * devfs_ctx,
-                     xptr_t        devfs_dev_inode_xp,
-                     xptr_t        devfs_external_inode_xp );
+void devfs_ctx_init( xptr_t    devfs_ctx_xp,
+                     xptr_t    devfs_dev_inode_xp,
+                     xptr_t    devfs_external_inode_xp );
 
 /*****************************************************************************************
@@ -83,14 +82,13 @@
  * @ devfs_ctx   : local pointer on DEVFS context.
  ****************************************************************************************/
-void devfs_ctx_destroy( devfs_ctx_t * devfs_ctx );
+void devfs_ctx_destroy( xptr_t  devfs_ctx_xp );
 
 /*****************************************************************************************
- * This function start to create the DEVFS subtree. 
- * This function should be called once in the cluster containing the VFS parent inode.
- * More precisely, it creates in cluster 0 the "dev" and "external" DEVFS directories.
- * For each one, it creates the inode and link the associated dentry to parent inode.
- * The DEVFS root inode is linked to the VFS parent inode identified by <parent_inode_xp>.
+ * This function starts to create the DEVFS subtree. 
+ * This function creates in cluster 0 the "dev" and "external" DEVFS directories.
+ * For each one, it creates the inode and the associated dentry. The DEVFS root inode
+ * <dev is linked to the VFS parent inode identified by <parent_inode_xp>.
  *****************************************************************************************
- * @ parent_inode_xp         : extended pointer on the parent VFS inode.
+ * @ parent_inode_xp         : [in]  extended pointer on the parent VFS inode.
  * @ devfs_dev_inode_xp      : [out] extended pointer on created <dev> inode.
  * @ devfs_external_inode_xp : [out] extended pointer on created <external> inode.
@@ -105,16 +103,14 @@
  * 1. In each cluster (i), it creates the "internal" directory, 
  *    linked to the DEVFS "dev" parent directory.
- * 2. In each cluster (i), it creates - for each external chdev in cluster (i) - 
+ * 2. In each cluster (i), it creates, for each external chdev in cluster (i), 
  *    a pseudo-file, linked to the DEVFS "external" parent directory.
- * 3. In each cluster (i), it creates - for each internal chdev in cluster (i) -
+ * 3. In each cluster (i), it creates, for each internal chdev in cluster (i),
  *    a pseudo-file, linked to the DEVFS "internal" parent directory.
  *****************************************************************************************
- * @ devfs_dev_inode_xp      : extended pointer on DEVFS root inode.
- * @ devfs_external_inode_xp : extended pointer on DEVFS external inode.
- * @ devfs_internal_inode_xp : [out] extended pointer on created <internal> inode.
+ * @ devfs_dev_inode_xp      : [in]  extended pointer on DEVFS root inode.
+ * @ devfs_external_inode_xp : [in]  extended pointer on DEVFS external inode.
  ****************************************************************************************/
 void devfs_local_init( xptr_t   devfs_dev_inode_xp,
-                       xptr_t   devfs_external_inode_xp,
-                       xptr_t * devfs_internal_inode_xp );
+                       xptr_t   devfs_external_inode_xp );
                        
 /****************************************************************************************** 
